import es
import hashlib
import time
import os
import esamlib
import cmdlib
from configobj import ConfigObj
import random

gamedir = str(es.ServerVar("eventscripts_gamedir")).replace("\\", "/")
addonpath = es.getAddonPath("chatadmin").replace("\\", "/")
config = ConfigObj(addonpath + "/chatadmin.ini")

info = es.AddonInfo()
info.name = "ChatAdmin"
info.version = "2.0.2"
info.author = "Brainsucker"
info.description = "Allows Admins to Kick or Ban Players by Chat or Consolecommand!"
info.url = "http://addons.eventscripts.com/addons/view/Chatadmin"

kcmd = str(config["fastkickcmd"])
bcmd = str(config["fastbancmd"])

def need_update():
	a = esamlib.getAddon("Chatadmin")
	try:
		newest_ver = a.currentversion
	except:
		return False
	else:
		if info["version"] != newest_ver:
			return True
	return False

def load():
	global logfile
	if hashlib.md5(info.author).hexdigest() == "e23f4403f295a005453317e0808f8f40":
		es.ServerVar(info.name, info.version + (" (New Version available)" if need_update() else "")).makepublic()
		if kcmd.lower() != bcmd.lower():
			if not es.exists("saycommand", kcmd):
				cmdlib.registerSayCommand(kcmd, fastkick, "Command for admins to kick a player by chat")
			if not es.exists("saycommand", bcmd):
				cmdlib.registerSayCommand(bcmd, fastban, "Command for admins to ban players by chat")
			if not es.exists("clientcommand", kcmd):
				cmdlib.registerClientCommand(kcmd, fastkick, "Command for admins to kick players by console")
			if not es.exists("clientcommand", bcmd):
				cmdlib.registerClientCommand(bcmd, fastban, "Command for admins to ban players by chat")

		else:
			es.dbgmsg(0, "%s: ERROR: Kickcommand and Bancommand are the same commands. Please change one of them!" % info.name)
			es.unload("chatadmin")
			return
			
		logfile = open(addonpath + "/adminlog.txt", "ab")
			
		if int(config["load_message"]):
			es.msg("#multi", "#default[#green%s#default] has been loaded..." % info.name)


def fastkick(userid, args):
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	if steamid in config["admins"]:
		if len(args) >= 1:
			arg1 = args[0]
			if checkuserid(arg1):
				plyuserid = checkuserid(arg1)

			else:
				giveKickExample(userid)
				return
			if len(args) > 1:
				kickreason = " ".join(args).replace(args[0] + " ", "")

			else:
				kickreason = None

			plyname = es.getplayername(plyuserid)
			log(time.strftime("%X"), time.strftime("%d.%m.%Y"), name, steamid, plyname, es.getplayersteamid(plyuserid), "kick", kickreason, None)
			es.server.queuecmd("kickid %s Kicked by Admin%s" % (plyuserid, (": %s" % kickreason) if kickreason else ""))


			if int(config["show_message"]):
				es.msg("#multi", "#default[ADMIN %s] Kicked Player #green%s" % (("#green%s#default" % name) if int(config["show_admin_name"]) else "", plyname))
					
		else:
			giveKickExample(userid)


def fastban(userid, args):
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	if steamid in config["admins"]:
		if len(args) >= 2:
			arg1 = args[0]
			if str(arg1).isdigit():
				bantime = int(arg1)

			else:
				giveBanExample(userid)
				return

			if checkuserid(args[1]):
				plyuserid = checkuserid(args[1])

			else:
				giveBanExample(userid)
				return

			if len(args) > 2:
				banreason = " ".join(args).replace(arg1 + " ", "").replace(args[1] + " ", "")

			else:
				banreason = None

			plyname = es.getplayername(plyuserid)
			es.server.queuecmd("banid %s %s" % (bantime, plyuserid))
			log(time.strftime("%X"), time.strftime("%d.%m.%Y"), name, steamid, plyname, es.getplayersteamid(plyuserid), "ban", banreason, bantime)
			es.server.queuecmd("kickid %s Banned by Admin%s" % (plyuserid, (": %s" % banreason) if banreason else ""))

			if int(config["show_message"]):
				es.msg("#multi", "#default[ADMIN %s] Banned Player #green%s" % (("#green%s#default" % name) if int(config["show_admin_name"]) else "", plyname))

			if bantime == 0:
				es.server.queuecmd("writeid")
		else:
			giveBanExample(userid)
def unload():
	cmdlib.unregisterSayCommand(kcmd)
	cmdlib.unregisterSayCommand(bcmd)
	cmdlib.unregisterClientCommand(kcmd)
	cmdlib.unregisterClientCommand(bcmd)
	logfile.close()
	if int(config["unload_message"]):
		es.msg("#multi", "#default[#green%s#default] has been unloaded..." % info.name)


def exists(a, b):
	uidlist = es.getUseridList()
	if a == "playername":
		for player in uidlist:
			if b == es.getplayername(player):
				return True

	if a == "userid":
		if int(b) in uidlist:
			return True

	if a == "steamid":
		if b in map(lambda temp: es.getplayersteamid(temp), uidlist):
			return True

	return False 

def checkuserid(argument):
	if str(argument).isdigit():
		if exists("userid", int(argument)):
			return argument

	if exists("steamid", argument):
		return es.getuserid(argument)

	if exists("playername", argument):
		return es.getuserid(argument)

	return False

def log(time, date, adminname, adminsteamid, username, usersteamid, punishtype, reason=None, bantime=None):
	if punishtype == "kick":
		logfile.write("\n\n-----\nKicked:")

	if punishtype == "ban":
		logfile.write("\n\n-----\nBanned:")

	logfile.write("\nDate: %s\nTime: %s\n\nAdmin:\nName: %s\nSTEAMID: %s\n\nUser:\nName: %s\nSTEAMID: %s" % (date, time, adminname, adminsteamid, username, usersteamid))

	if bantime != None:
		if bantime == 0:
			logfile.write("\nBantime: PERMANENT")

		else:
			logfile.write("\nBantime: %i" % bantime)

	if reason:
		logfile.write("\n\nReason: %s" % reason)

	logfile.write("\n-----")
		
	logfile.flush()


def giveKickExample(userid):
	randuserid = random.choice(es.getUseridList())
	es.tell(userid, "#multi", "#defaultExample Kick by Userid: #green%s %s#default." % (kcmd, randuserid))
	es.tell(userid, "#multi", "#defaultExample Kick by Username: #green%s %s#default." % (kcmd, es.getplayername(randuserid)))
	es.tell(userid, "#multi", "#defaultExample Kick by STEAMID: #green%s %s#default." % (kcmd, es.getplayersteamid(randuserid)))
	es.tell(userid, "#multi", "#defaultYou also can add a reason to the end of the command")


def giveBanExample(userid):
	randuserid = random.choice(es.getUseridList())
	randbantime = random.randint(0, 200)
	es.tell(userid, "#multi", "#defaultExample Ban by Userid: #green%s %i %s#default." % (bcmd, randbantime, randuserid))
	es.tell(userid, "#multi", "#defaultExample Ban by Username: #green%s %i %s#default." % (bcmd, randbantime, es.getplayername(randuserid)))
	es.tell(userid, "#multi", "#defaultExample Ban by STEAMID: #green%s %i %s#default." % (bcmd, randbantime, es.getplayersteamid(randuserid)))
	es.tell(userid, "#multi", "#defaultThis Commads would ban the User %s for %i Minutes" % (es.getplayername(randuserid), randbantime))
	es.tell(userid, "#multi", "#defaultYou also can add a reason to the end of the command")